package com.lightinit.hsdatagateway.modules.foreign.util;

import org.apache.commons.codec.binary.Base64;
import org.apache.commons.lang3.StringUtils;

import javax.crypto.Cipher;
import java.io.ByteArrayOutputStream;
import java.security.*;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;

/**
 * 通信协议加解密工具类
 *
 * @Author: yangrui
 * @Date: 2019/3/5 16:00
 */

public class ApiEncryptUtil {

    /**
     * RSA最大加密明文大小
     */
    private static final int MAX_ENCRYPT_BLOCK = 117;

    /**
     * RSA最大解密密文大小
     */
    private static final int MAX_DECRYPT_BLOCK = 128;

    /**
     * 获取密钥对
     *
     * @return 密钥对
     */
    public static KeyPair getKeyPair() throws Exception {
        KeyPairGenerator generator = KeyPairGenerator.getInstance("RSA");
        generator.initialize(1024);
        return generator.generateKeyPair();
    }

    /**
     * 获取私钥
     *
     * @param privateKey 私钥字符串
     * @return
     */
    public static PrivateKey getPrivateKey(String privateKey) throws Exception {
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        byte[] decodedKey = Base64.decodeBase64(privateKey.getBytes());
        PKCS8EncodedKeySpec keySpec = new PKCS8EncodedKeySpec(decodedKey);
        return keyFactory.generatePrivate(keySpec);
    }

    /**
     * 获取公钥
     *
     * @param publicKey 公钥字符串
     * @return
     */
    public static PublicKey getPublicKey(String publicKey) throws Exception {
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        byte[] decodedKey = Base64.decodeBase64(publicKey.getBytes());
        X509EncodedKeySpec keySpec = new X509EncodedKeySpec(decodedKey);
        return keyFactory.generatePublic(keySpec);
    }

    /**
     * RSA加密
     *
     * @param data 待加密数据
     * @param publicKey 公钥
     * @return
     */
    public static String encrypt(String data, PublicKey publicKey) throws Exception {
        Cipher cipher = Cipher.getInstance("RSA");
        cipher.init(Cipher.ENCRYPT_MODE, publicKey);
        int inputLen = data.getBytes().length;
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        int offset = 0;
        byte[] cache;
        int i = 0;
        // 对数据分段加密
        while (inputLen - offset > 0) {
            if (inputLen - offset > MAX_ENCRYPT_BLOCK) {
                cache = cipher.doFinal(data.getBytes(), offset, MAX_ENCRYPT_BLOCK);
            } else {
                cache = cipher.doFinal(data.getBytes(), offset, inputLen - offset);
            }
            out.write(cache, 0, cache.length);
            i++;
            offset = i * MAX_ENCRYPT_BLOCK;
        }
        byte[] encryptedData = out.toByteArray();
        out.close();
        // 获取加密内容使用base64进行编码,并以UTF-8为标准转化成字符串
        // 加密后的字符串
        return new String(Base64.encodeBase64String(encryptedData));
    }

    /**
     * RSA解密
     *
     * @param data 待解密数据
     * @param privateKey 私钥
     * @return
     */
    public static String decrypt(String data, PrivateKey privateKey) throws Exception {
        Cipher cipher = Cipher.getInstance("RSA");
        cipher.init(Cipher.DECRYPT_MODE, privateKey);
        byte[] dataBytes = Base64.decodeBase64(data);
        int inputLen = dataBytes.length;
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        int offset = 0;
        byte[] cache;
        int i = 0;
        // 对数据分段解密
        while (inputLen - offset > 0) {
            if (inputLen - offset > MAX_DECRYPT_BLOCK) {
                cache = cipher.doFinal(dataBytes, offset, MAX_DECRYPT_BLOCK);
            } else {
                cache = cipher.doFinal(dataBytes, offset, inputLen - offset);
            }
            out.write(cache, 0, cache.length);
            i++;
            offset = i * MAX_DECRYPT_BLOCK;
        }
        byte[] decryptedData = out.toByteArray();
        out.close();
        // 解密后的内容
        return new String(decryptedData, "UTF-8");
    }

    /**
     * 签名
     *
     * @param data 待签名数据
     * @param privateKey 私钥
     * @return 签名
     */
    public static String sign(String data, PrivateKey privateKey) throws Exception {
        byte[] keyBytes = privateKey.getEncoded();
        PKCS8EncodedKeySpec keySpec = new PKCS8EncodedKeySpec(keyBytes);
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        PrivateKey key = keyFactory.generatePrivate(keySpec);
        Signature signature = Signature.getInstance("MD5withRSA");
        signature.initSign(key);
        signature.update(data.getBytes());
        return new String(Base64.encodeBase64(signature.sign()));
    }

    /**
     * 验签
     *
     * @param srcData 原始字符串
     * @param publicKey 公钥
     * @param sign 签名
     * @return 是否验签通过
     */
    public static boolean verify(String srcData, PublicKey publicKey, String sign) throws Exception {
        byte[] keyBytes = publicKey.getEncoded();
        X509EncodedKeySpec keySpec = new X509EncodedKeySpec(keyBytes);
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        PublicKey key = keyFactory.generatePublic(keySpec);
        Signature signature = Signature.getInstance("MD5withRSA");
        signature.initVerify(key);
        signature.update(srcData.getBytes());
        return signature.verify(Base64.decodeBase64(sign.getBytes()));
    }

//    public static void main(String[] args) {
//        try {
//            // 生成密钥对
//            KeyPair keyPair = getKeyPair();
//            String privateKey = new String(Base64.encodeBase64(keyPair.getPrivate().getEncoded()));
//            String publicKey = new String(Base64.encodeBase64(keyPair.getPublic().getEncoded()));
//            System.out.println("私钥:" + privateKey);
//            System.out.println("公钥:" + publicKey);
//            // RSA加密
//            String data = "待加密的文字内容";
//            String encryptData = encrypt(data, getPublicKey(publicKey));
//            System.out.println("加密后内容:" + encryptData);
//            // RSA解密
//            String decryptData = decrypt(encryptData, getPrivateKey(privateKey));
//            System.out.println("解密后内容:" + decryptData);
//
//            // RSA签名
//            String sign = sign(data, getPrivateKey(privateKey));
//            // RSA验签
//            boolean result = verify(data, getPublicKey(publicKey), sign);
//            System.out.print("验签结果:" + result);
//        } catch (Exception e) {
//            e.printStackTrace();
//            System.out.print("加解密异常");
//        }
//    }

//    public static void main(String[] args) throws Exception{
//        String s = "1554375843608";
//        String encrypt = ApiEncryptUtil.encrypt("app1551771060908923486admin"+s, ApiEncryptUtil.getPublicKey("MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCbpKwxZXFFtQo32wY/dQxjtT0cfGmLNjqa6GaipYw2NNPiuFZW2L9MCtQIu5M2B4otGhO+yox9M63wemAP4BgNW42EjlHE+AvoGXTiHM1kc+MDJ9TWMY7z39tt/qzCCOyLHRNIGkmhUeZR3btv/3/Pxwd5dlb2Ir0Qm+BNc7X3xwIDAQAB"));
//        System.out.println(encrypt);
//        String encrypt1 = "gnXqBShz+9ztObytZMt1tk5QXl531WKpGLeGAyE9WD6CYDuo0qvAkNyNcfZApzB1lWcRefb6gguKwKmkxBAe8pSkDExn2SRdquRjWZN4RVzeFrxHn8EvyihjoYElmNl/qSL9QRDo+1gFOkn/BLOnP/hR/OKcEB6ZqJC44JbJxoU=";
//        String decrypt = ApiEncryptUtil.decrypt(encrypt1, ApiEncryptUtil.getPrivateKey("MIICdQIBADANBgkqhkiG9w0BAQEFAASCAl8wggJbAgEAAoGBAJukrDFlcUW1CjfbBj91DGO1PRx8aYs2OproZqKljDY00+K4VlbYv0wK1Ai7kzYHii0aE77KjH0zrfB6YA/gGA1bjYSOUcT4C+gZdOIczWRz4wMn1NYxjvPf223+rMII7IsdE0gaSaFR5lHdu2//f8/HB3l2VvYivRCb4E1ztffHAgMBAAECgYBOukcXXVakieS3SCSq6Ivxy3Uz+YJxlmaigLeZwd9gc+xRnCigGVb6IegK2sal575u/efK9C2IDyIGp//7R8EiAg/NbCJSRTdHlflmZ2QIijIVyXWMT0cS62GpQK8z1J0e9xhPSIMO4n1TBP6Ek78D/VbEvIm02tOjv0uMaERO8QJBAPbd8GCb/y6JqvDmkZIlucOPbLH5VipGeBplbYm0Me1nk8O3BkHHcg145Ti/nKefrVZ05ZJlD6gg88LlyMDb1EsCQQChZsKHgkqeBO2HsG35PMXW12Uh+yYKMQlaBXr+lPhM75X/dgBCmOSz3HJLe9ofHlVX8o1Q87JVKt2rpzH2I+T1AkBdvsQEe9i4nHC8kGIhRJA5ciKNpyiQXzhGldO14ia/h4C2Zq9KlWl7Mjihhyn/AYT6euOe5x+98d1/WnEUw6XnAkARRhQvuIwP2WsqiIFcmVp7IdZbCqwJjzH3BnshYAQrB8E/8/sXJZHkhgVdesXfarmrjfP94/cEEnBi/KPmOfU5AkAZo4XLUvReqyaTOaSe+qRs7xkkMVVRXBLpLF99FnzoiMgpIt3EMf6mG5MTeyIQuLKJZdo07alowOcJxUtDQalR"));
//        System.out.println(s);
//        System.out.println(("app1551771060908923486admin"+s).equals(decrypt));
//
//        String s1 = new StringBuilder().append("app1551771060908923486" .trim())
//                .append("admin" .trim())
//                .append("1554375843608" .trim())
//                .toString();
//        System.out.println(StringUtils.equals(s1, decrypt));
//    }
}
